/* Program RESIST.C */
/* By Harald Stauss */
/* Last change 07.11.95 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "/home/stauss/tsa/tsa.h"

main(int argc, char *argv[])
{
  short    i;
  unsigned long     n;
  char     *fin1,*fin2,*fout,*ftin1,*ftin2,*ftout;
  char     *pfin1, *pfin2, *pfout, *pftin1, *pftin2, *pftout;
  REGIST   r1,r2,r3;


  /* H e l l o   w o r l d */
  cout << "RESIST Ver.1.0 by H. Stauss, 1995 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin1=(char *)malloc(255); pfin1=fin1;
  fin2=(char *)malloc(255); pfin2=fin2;
  fout=(char *)malloc(255); pfout=fout;
  ftin1=(char *)malloc(255); pftin1=ftin1;
  ftin2=(char *)malloc(255); pftin2=ftin2;
  ftout=(char *)malloc(255); pftout=ftout;

  /* P a r a m e t e r   e i n l e s e n */
  if (argc != 4)
    {
      cout << "Number of parameters wrong! \n";
      cout << "resist f_in1 f_in2 f_out  \n";
      cout << "calculates f_in1 / f_in2  \n";
      cout << "f_in1 : name of input file 1 (*.TSA, *.ASC). \n";
      cout << "f_in2 : name of input file 2 (*.TSA, *.ASC). \n";
      cout << "f_out : name of output file (*.TSA, *.ASC). \n";
      goto ende;
    }
  strcpy(fin1,argv[1]);
  strcpy(fin2,argv[2]);
  strcpy(fout,argv[3]);
  strcpy(ftin1,fin1);
  strcpy(ftin2,fin2);
  strcpy(ftout,fout);
  pftin1=strrchr(ftin1,'.');
  for (i=0; pftin1[i]; i++) pftin1[i]=toupper(pftin1[i]);
  pftin2=strrchr(ftin2,'.');
  for (i=0; pftin2[i]; i++) pftin2[i]=toupper(pftin2[i]);
  pftout=strrchr(ftout,'.');
  for (i=0; pftout[i]; i++) pftout[i]=toupper(pftout[i]);

  printf("Input file1 : %s \n",fin1);
  printf("Input file2 : %s \n",fin2);
  printf("Output file : %s \n",fout);

  /* E i n g a b e d a t e i e n   o e f f n e n */
  if (strcmp(pftin1,".TSA")==0) r1.ReadTSA(fin1);
  if (strcmp(pftin1,".ASC")==0) r1.ReadASCII(fin1,1);
  if ((strcmp(pftin1,".TSA")!=0) && (strcmp(pftin1,".ASC")!=0)) {
    cout << "File type for input file 1 not recognized! \n";
    goto ende;
  }
  printf("Number of channels in file 1  : %d  \n",r1.n);

  if (strcmp(pftin2,".TSA")==0) r2.ReadTSA(fin2);
  if (strcmp(pftin2,".ASC")==0) r2.ReadASCII(fin2,1);
  if ((strcmp(pftin2,".TSA")!=0) && (strcmp(pftin2,".ASC")!=0)) {
    cout << "File type for input file 2 not recognized! \n";
    goto ende;
  }
  printf("Number of channels in file 2  : %d  \n",r2.n);

  for (i=0; i<r1.n; i++)
    r3.AddChannel(r1.ch[i].n, r1.ch[i].sr, r1.ch[i].min, r1.ch[i].max,
		  r1.ch[i].res, r1.ch[i].name, r1.ch[i].unit);

  /* M A I N L O O P  */
  for (i=0; i < r1.n; i++) {
    cout << "n in channel " << i+1 << ": " << r1.ch[i].n << "\n";
    for (n=0; n<r1.ch[i].n; n++) {
      if (r2.ch[i].data[n]!=0)
	r3.ch[i].data[n]=r1.ch[i].data[n]/r2.ch[i].data[n];
      else {
	r3.ch[i].data[n]=0;
	cout << "division by 0 in channel " << i+1 << " line " << n+1 << "\n";
      }
    }
  } /* endfor */

  /* D a t e i   s c h r e i b e n */
  if (strcmp(pftout,".TSA")==0) r3.WriteTSA(fout);
  if (strcmp(pftout,".ASC")==0) r3.WriteASCII(fout);
  if ((strcmp(pftout,".TSA")!=0) && (strcmp(pftout,".ASC")!=0)) {
    printf("File type for output not recognized! \n");
    goto ende;
  }

 ende:
  free(fin1);free(ftin1);free(fin2);free(ftin2);free(fout);free(ftout);
  return(0);
} /* Ende von main */
